## multipath-tools 0.7.4

=== Makefile ===
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@opensvc.com>
#

BUILDDIRS = \
	libmpathcmd \
	libmultipath \
	libmultipath/prioritizers \
	libmultipath/checkers \
	libmpathpersist \
	multipath \
	multipathd \
	mpathpersist \
	kpartx

ifneq ($(ENABLE_LIBDMMP),0)
BUILDDIRS += \
	libdmmp
endif

all: recurse

recurse:
	@for dir in $(BUILDDIRS); do $(MAKE) -C $$dir || exit $?; done

recurse_clean:
	@for dir in $(BUILDDIRS); do \
	$(MAKE) -C $$dir clean || exit $?; \
	done

recurse_install:
	@for dir in $(BUILDDIRS); do \
	$(MAKE) -C $$dir install || exit $?; \
	done

recurse_uninstall:
	@for dir in $(BUILDDIRS); do \
	$(MAKE) -C $$dir uninstall || exit $?; \
	done

clean: recurse_clean

install: recurse_install

uninstall: recurse_uninstall

.PHONY:	TAGS
TAGS:
	etags -a libmultipath/*.c
	etags -a libmultipath/*.h
	etags -a multipathd/*.c
	etags -a multipathd/*.h

=== kpartx/Makefile ===
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@opensvc.com>
#
include ../Makefile.inc

CFLAGS += $(BIN_CFLAGS) -I. -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
LDFLAGS += $(BIN_LDFLAGS)

LIBDEPS += -ldevmapper

ifneq ($(call check_func,dm_task_set_cookie,/usr/include/libdevmapper.h),0)
	CFLAGS += -DLIBDM_API_COOKIE
endif

OBJS = bsd.o dos.o kpartx.o solaris.o unixware.o dasd.o sun.o \
	gpt.o mac.o ps3.o crc32.o lopart.o xstrncpy.o devmapper.o

EXEC = kpartx

all: $(EXEC)

$(EXEC): $(OBJS)
	$(CC) $(CFLAGS) $(OBJS) -o $(EXEC) $(LDFLAGS) $(LIBDEPS)
	$(GZIP) $(EXEC).8 > $(EXEC).8.gz

install: $(EXEC) $(EXEC).8
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(bindir)
	$(INSTALL_PROGRAM) -m 755 $(EXEC) $(DESTDIR)$(bindir)
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(libudevdir)
	$(INSTALL_PROGRAM) -m 755 kpartx_id $(DESTDIR)$(libudevdir)
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(libudevdir)/rules.d
	$(INSTALL_PROGRAM) -m 644 dm-parts.rules $(DESTDIR)$(libudevdir)/rules.d/11-dm-parts.rules
	$(INSTALL_PROGRAM) -m 644 kpartx.rules $(DESTDIR)$(libudevdir)/rules.d/66-kpartx.rules
	$(INSTALL_PROGRAM) -m 644 del-part-nodes.rules $(DESTDIR)$(libudevdir)/rules.d/68-del-part-nodes.rules
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(man8dir)
	$(INSTALL_PROGRAM) -m 644 $(EXEC).8.gz $(DESTDIR)$(man8dir)

uninstall:
	$(RM) $(DESTDIR)$(bindir)/$(EXEC)
	$(RM) $(DESTDIR)$(man8dir)/$(EXEC).8.gz
	$(RM) $(DESTDIR)$(libudevdir)/kpartx_id
	$(RM) $(DESTDIR)$(libudevdir)/rules.d/11-dm-parts.rules
	$(RM) $(DESTDIR)$(libudevdir)/rules.d/66-kpartx.rules
	$(RM) $(DESTDIR)$(libudevdir)/rules.d/67-kpartx-compat.rules
	$(RM) $(DESTDIR)$(libudevdir)/rules.d/68-del-part-nodes.rules

clean:
	$(RM) core *.o $(EXEC) *.gz

=== libdmmp/Makefile ===
# Makefile
#
# Copyright (C) 2015 - 2016 Red Hat, Inc.
# Gris Ge <fge@redhat.com>
#
include ../Makefile.inc

LIBDMMP_VERSION=0.1.0
SONAME=$(LIBDMMP_VERSION)
DEVLIB = libdmmp.so
LIBS = $(DEVLIB).$(SONAME)
PKGFILE = libdmmp.pc
EXTRA_MAN_FILES = libdmmp.h.3
HEADERS = libdmmp/libdmmp.h

OBJS = libdmmp.o libdmmp_mp.o libdmmp_pg.o libdmmp_path.o libdmmp_misc.o

CFLAGS += $(LIB_CFLAGS) -fvisibility=hidden -I$(libdmmpdir) -I$(mpathcmddir) \
	  $(shell pkg-config --cflags json-c)

LIBDEPS += $(shell pkg-config --libs json-c) -L$(mpathcmddir) -lmpathcmd -lpthread

all: $(LIBS) doc

$(LIBS): $(OBJS)
	$(CC) $(LDFLAGS) $(SHARED_FLAGS) -Wl,-soname=$@ -o $@ $(OBJS) $(LIBDEPS)
	$(LN) $@ $(DEVLIB)

install:
	mkdir -p $(DESTDIR)$(usrlibdir)
	$(INSTALL_PROGRAM) -m 755 $(LIBS) $(DESTDIR)$(usrlibdir)/$(LIBS)
	$(INSTALL_PROGRAM) -m 644 -D \
		$(HEADERS) $(DESTDIR)$(includedir)/$(HEADERS)
	$(LN) $(LIBS) $(DESTDIR)$(usrlibdir)/$(DEVLIB)
	$(INSTALL_PROGRAM) -m 644 -D \
		$(PKGFILE).in $(DESTDIR)$(pkgconfdir)/$(PKGFILE)
	perl -i -pe 's|__VERSION__|$(LIBDMMP_VERSION)|g' \
		$(DESTDIR)$(pkgconfdir)/$(PKGFILE)
	perl -i -pe 's|__LIBDIR__|$(usrlibdir)|g' \
		$(DESTDIR)$(pkgconfdir)/$(PKGFILE)
	perl -i -pe 's|__INCLUDEDIR__|$(includedir)|g' \
		$(DESTDIR)$(pkgconfdir)/$(PKGFILE)
	@for file in docs/man/*.3.gz; do \
		$(INSTALL_PROGRAM) -m 644 -D \
			$$file \
			$(DESTDIR)$(man3dir)/ || exit $?; \
	done

uninstall:
	$(RM) $(DESTDIR)$(usrlibdir)/$(LIBS)
	$(RM) $(DESTDIR)$(includedir)/$(HEADERS)
	$(RM) $(DESTDIR)$(usrlibdir)/$(DEVLIB)
	@for file in $(DESTDIR)$(man3dir)/dmmp_*; do \
		$(RM) $$file; \
	done
	$(RM) $(DESTDIR)$(man3dir)/libdmmp.h*
	$(RM) $(DESTDIR)$(pkgconfdir)/$(PKGFILE)

clean:
	$(RM) core *.a *.o *.gz *.so *.so.*
	$(RM) -r docs/man
	$(MAKE) -C test clean

check: all
	$(MAKE) -C test check

speed_test: all
	$(MAKE) -C test speed_test

doc: docs/man/$(EXTRA_MAN_FILES).gz

TEMPFILE := $(shell mktemp)

docs/man/$(EXTRA_MAN_FILES).gz: $(HEADERS)
	@for file in $(EXTRA_MAN_FILES); do \
		$(INSTALL_PROGRAM) -v -m 644 -D docs/$$file docs/man/$$file; \
	done
	cat $(HEADERS) | \
	    perl docs/doc-preclean.pl > "$(TEMPFILE)"
	perl docs/kernel-doc -man "$(TEMPFILE)" | \
	    perl docs/split-man.pl docs/man
	-rm -f "$(TEMPFILE)"
	@for file in docs/man/*.3; do \
		gzip -f $$file; \
	done
	find docs/man -type f -name \*[0-9].gz

=== libmpathcmd/Makefile ===
include ../Makefile.inc

SONAME = 0
DEVLIB = libmpathcmd.so
LIBS = $(DEVLIB).$(SONAME)

CFLAGS += $(LIB_CFLAGS)

OBJS = mpath_cmd.o

all: $(LIBS)

$(LIBS): $(OBJS)
	$(CC) $(LDFLAGS) $(SHARED_FLAGS) -Wl,-soname=$@ -o $@ $(OBJS) $(LIBDEPS)
	$(LN) $@ $(DEVLIB)

install: $(LIBS)
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(syslibdir)
	$(INSTALL_PROGRAM) -m 755 $(LIBS) $(DESTDIR)$(syslibdir)/$(LIBS)
	$(LN) $(LIBS) $(DESTDIR)$(syslibdir)/$(DEVLIB)
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(includedir)
	$(INSTALL_PROGRAM) -m 644 mpath_cmd.h $(DESTDIR)$(includedir)

uninstall:
	$(RM) $(DESTDIR)$(syslibdir)/$(LIBS)
	$(RM) $(DESTDIR)$(syslibdir)/$(DEVLIB)
	$(RM) $(DESTDIR)$(includedir)/mpath_cmd.h

clean:
	$(RM) core *.a *.o *.so *.so.* *.gz

=== libmpathpersist/Makefile ===
include ../Makefile.inc

SONAME = 0
DEVLIB = libmpathpersist.so
LIBS = $(DEVLIB).$(SONAME)

CFLAGS += $(LIB_CFLAGS) -I$(multipathdir) -I$(mpathpersistdir) -I$(mpathcmddir)

LIBDEPS += -lpthread -ldevmapper -ldl -L$(multipathdir) -lmultipath \
	   -L$(mpathcmddir) -lmpathcmd

OBJS = mpath_persist.o mpath_updatepr.o mpath_pr_ioctl.o

all: $(LIBS)

$(LIBS): $(OBJS)
	$(CC) $(LDFLAGS) $(SHARED_FLAGS) $(LIBDEPS) -Wl,-soname=$@ -o $@ $(OBJS)
	$(LN) $(LIBS) $(DEVLIB)
	$(GZIP) mpath_persistent_reserve_in.3 > mpath_persistent_reserve_in.3.gz
	$(GZIP) mpath_persistent_reserve_out.3 > mpath_persistent_reserve_out.3.gz

install: $(LIBS)
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(syslibdir)
	$(INSTALL_PROGRAM) -m 755 $(LIBS) $(DESTDIR)$(syslibdir)/$(LIBS)
	$(INSTALL_PROGRAM) -m 755 -d $(DESTDIR)$(syslibdir)
	$(INSTALL_PROGRAM) -m 755 -d $(DESTDIR)$(man3dir)
	$(INSTALL_PROGRAM) -m 755 -d $(DESTDIR)$(includedir)
	$(LN) $(LIBS) $(DESTDIR)$(syslibdir)/$(DEVLIB)
	$(INSTALL_PROGRAM) -m 644 mpath_persistent_reserve_in.3.gz $(DESTDIR)$(man3dir)
	$(INSTALL_PROGRAM) -m 644 mpath_persistent_reserve_out.3.gz $(DESTDIR)$(man3dir)
	$(INSTALL_PROGRAM) -m 644 mpath_persist.h $(DESTDIR)$(includedir)

uninstall:
	$(RM) $(DESTDIR)$(syslibdir)/$(LIBS)
	$(RM) $(DESTDIR)$(man3dir)/mpath_persistent_reserve_in.3.gz
	$(RM) $(DESTDIR)$(man3dir)/mpath_persistent_reserve_out.3.gz
	$(RM) $(DESTDIR)$(includedir)/mpath_persist.h
	$(RM) $(DESTDIR)$(syslibdir)/$(DEVLIB)

clean:
	$(RM) core *.a *.o *.so *.so.* *.gz

=== libmultipath/Makefile ===
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@opensvc.com>
#
include ../Makefile.inc

SONAME = 0
DEVLIB = libmultipath.so
LIBS = $(DEVLIB).$(SONAME)

CFLAGS += $(LIB_CFLAGS) -I$(mpathcmddir)

LIBDEPS += -lpthread -ldl -ldevmapper -ludev -L$(mpathcmddir) -lmpathcmd -lurcu -laio

ifdef SYSTEMD
	CFLAGS += -DUSE_SYSTEMD=$(SYSTEMD)
	ifeq ($(shell test $(SYSTEMD) -gt 209 && echo 1), 1)
		LIBDEPS += -lsystemd
	else
		LIBDEPS += -lsystemd-daemon
	endif
endif

ifneq ($(call check_func,dm_task_no_flush,/usr/include/libdevmapper.h),0)
	CFLAGS += -DLIBDM_API_FLUSH -D_GNU_SOURCE
endif

ifneq ($(call check_func,dm_task_set_cookie,/usr/include/libdevmapper.h),0)
	CFLAGS += -DLIBDM_API_COOKIE
endif

ifneq ($(call check_func,udev_monitor_set_receive_buffer_size,/usr/include/libudev.h),0)
	CFLAGS += -DLIBUDEV_API_RECVBUF
endif

ifneq ($(call check_func,dm_task_deferred_remove,/usr/include/libdevmapper.h),0)
	CFLAGS += -DLIBDM_API_DEFERRED
endif

OBJS = memory.o parser.o vector.o devmapper.o callout.o \
	hwtable.o blacklist.o util.o dmparser.o config.o \
	structs.o discovery.o propsel.o dict.o \
	pgpolicies.o debug.o defaults.o uevent.o time-util.o \
	switchgroup.o uxsock.o print.o alias.o log_pthread.o \
	log.o configure.o structs_vec.o sysfs.o prio.o checkers.o \
	lock.o waiter.o file.o wwids.o prioritizers/alua_rtpg.o prkey.o \
	io_err_stat.o

all: $(LIBS)

$(LIBS): $(OBJS)
	$(CC) $(LDFLAGS) $(SHARED_FLAGS) -Wl,-soname=$@ -o $@ $(OBJS) $(LIBDEPS)
	$(LN) $@ $(DEVLIB)

install:
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(syslibdir)
	$(INSTALL_PROGRAM) -m 755 $(LIBS) $(DESTDIR)$(syslibdir)/$(LIBS)
	$(INSTALL_PROGRAM) -m 755 -d $(DESTDIR)$(libdir)
	$(LN) $(LIBS) $(DESTDIR)$(syslibdir)/$(DEVLIB)

uninstall:
	$(RM) $(DESTDIR)$(syslibdir)/$(LIBS)
	$(RM) $(DESTDIR)$(syslibdir)/$(DEVLIB)

clean:
	$(RM) core *.a *.o *.so *.so.* *.gz

=== mpathpersist/Makefile ===
include ../Makefile.inc

CFLAGS += $(BIN_CFLAGS) -I$(multipathdir) -I$(mpathpersistdir)
LDFLAGS += $(BIN_LDFLAGS)

LIBDEPS += -L$(mpathpersistdir) -lmpathpersist -L$(multipathdir) -lmultipath \
	-L$(mpathcmddir) -lmpathcmd -lpthread -ldevmapper -ludev

EXEC = mpathpersist

OBJS = main.o

all: $(EXEC)

$(EXEC): $(OBJS)
	$(CC) $(OBJS) -o $(EXEC) $(LDFLAGS) $(CFLAGS) $(LIBDEPS)
	$(GZIP) $(EXEC).8 > $(EXEC).8.gz

install:
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(bindir)
	$(INSTALL_PROGRAM) -m 755 $(EXEC) $(DESTDIR)$(bindir)/
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(man8dir)
	$(INSTALL_PROGRAM) -m 644 $(EXEC).8.gz $(DESTDIR)$(man8dir)

clean:
	$(RM) core *.o $(EXEC) *.gz

uninstall:
	$(RM) $(DESTDIR)$(bindir)/$(EXEC)
	$(RM) $(DESTDIR)$(man8dir)/$(EXEC).8.gz

=== multipath/Makefile ===
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@opensvc.com>
#
include ../Makefile.inc

CFLAGS += $(BIN_CFLAGS) -I$(multipathdir) -I$(mpathcmddir)
LDFLAGS += $(BIN_LDFLAGS)
LIBDEPS += -L$(multipathdir) -lmultipath -L$(mpathcmddir) -lmpathcmd \
	-lpthread -ldevmapper -ldl -ludev

EXEC = multipath

OBJS = main.o

all: $(EXEC)

$(EXEC): $(OBJS)
	$(CC) $(CFLAGS) $(OBJS) -o $(EXEC) $(LDFLAGS) $(LIBDEPS)
	$(GZIP) $(EXEC).8 > $(EXEC).8.gz
	$(GZIP) $(EXEC).conf.5 > $(EXEC).conf.5.gz

install:
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(bindir)
	$(INSTALL_PROGRAM) -m 755 $(EXEC) $(DESTDIR)$(bindir)/
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(udevrulesdir)
	$(INSTALL_PROGRAM) -m 644 11-dm-mpath.rules $(DESTDIR)$(udevrulesdir)
	$(INSTALL_PROGRAM) -m 644 $(EXEC).rules $(DESTDIR)$(libudevdir)/rules.d/56-multipath.rules
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(man8dir)
	$(INSTALL_PROGRAM) -m 644 $(EXEC).8.gz $(DESTDIR)$(man8dir)
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(man5dir)
	$(INSTALL_PROGRAM) -m 644 $(EXEC).conf.5.gz $(DESTDIR)$(man5dir)

uninstall:
	$(RM) $(DESTDIR)$(bindir)/$(EXEC)
	$(RM) $(DESTDIR)$(udevrulesdir)/11-dm-mpath.rules
	$(RM) $(DESTDIR)$(libudevdir)/rules.d/56-multipath.rules
	$(RM) $(DESTDIR)$(man8dir)/$(EXEC).8.gz
	$(RM) $(DESTDIR)$(man5dir)/$(EXEC).conf.5.gz

clean:
	$(RM) core *.o $(EXEC) *.gz

=== multipathd/Makefile ===
include ../Makefile.inc

#
# debugging stuff
#
#CFLAGS += -DLCKDBG
#CFLAGS += -D_DEBUG_
#CFLAGS += -DLOGDBG
CFLAGS += $(BIN_CFLAGS) -I$(multipathdir) -I$(mpathpersistdir) \
	  -I$(mpathcmddir) -I$(thirdpartydir)
LDFLAGS += $(BIN_LDFLAGS)
LIBDEPS += -L$(multipathdir) -lmultipath -L$(mpathpersistdir) -lmpathpersist \
	   -L$(mpathcmddir) -lmpathcmd -ludev -ldl -lurcu -lpthread \
	   -ldevmapper -lreadline

ifdef SYSTEMD
	CFLAGS += -DUSE_SYSTEMD=$(SYSTEMD)
	ifeq ($(shell test $(SYSTEMD) -gt 209 && echo 1), 1)
		LIBDEPS += -lsystemd
	else
		LIBDEPS += -lsystemd-daemon
	endif
endif

OBJS = main.o pidfile.o uxlsnr.o uxclnt.o cli.o cli_handlers.o

EXEC = multipathd

all : $(EXEC)

$(EXEC): $(OBJS)
	$(CC) $(CFLAGS) $(OBJS) $(LDFLAGS) -o $(EXEC) $(LIBDEPS)
	$(GZIP) $(EXEC).8 > $(EXEC).8.gz

install:
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(bindir)
	$(INSTALL_PROGRAM) -m 755 $(EXEC) $(DESTDIR)$(bindir)
ifdef SYSTEMD
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(unitdir)
	$(INSTALL_PROGRAM) -m 644 $(EXEC).service $(DESTDIR)$(unitdir)
	$(INSTALL_PROGRAM) -m 644 $(EXEC).socket $(DESTDIR)$(unitdir)
endif
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(man8dir)
	$(INSTALL_PROGRAM) -m 644 $(EXEC).8.gz $(DESTDIR)$(man8dir)

uninstall:
	$(RM) $(DESTDIR)$(bindir)/$(EXEC)
	$(RM) $(DESTDIR)$(man8dir)/$(EXEC).8.gz
	$(RM) $(DESTDIR)$(unitdir)/$(EXEC).service
	$(RM) $(DESTDIR)$(unitdir)/$(EXEC).socket

clean:
	$(RM) core *.o $(EXEC) *.gz

=== libdmmp/test/Makefile ===
# Makefile
#
# Copyright (C) 2015-2016 Gris Ge <fge@redhat.com>
#
include ../../Makefile.inc

_libdmmpdir=../$(libdmmpdir)
_mpathcmddir=../$(mpathcmddir)

TEST_EXEC = libdmmp_test
SPD_TEST_EXEC = libdmmp_speed_test
CFLAGS += -I$(_libdmmpdir)
LDFLAGS += -L$(_libdmmpdir) -ldmmp

all: $(TEST_EXEC) $(SPD_TEST_EXEC)

check: $(TEST_EXEC) $(SPD_TEST_EXEC)
	sudo env LD_LIBRARY_PATH=$(_libdmmpdir):$(_mpathcmddir) \
		valgrind --quiet --leak-check=full \
		--show-reachable=no --show-possibly-lost=no \
		--trace-children=yes --error-exitcode=1 \
		./$(TEST_EXEC)
	$(MAKE) speed_test

speed_test: $(SPD_TEST_EXEC)
	sudo env LD_LIBRARY_PATH=$(_libdmmpdir):$(_mpathcmddir) \
		time -p ./$(SPD_TEST_EXEC)

clean:
	rm -f $(TEST_EXEC) $(SPD_TEST_EXEC)

=== libmultipath/checkers/Makefile ===
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@opensvc.com>
#
include ../../Makefile.inc

CFLAGS += $(LIB_CFLAGS) -I..

# If you add or remove a checker also update multipath/multipath.conf.5
LIBS= \
	libcheckcciss_tur.so \
	libcheckreadsector0.so \
	libchecktur.so \
	libcheckdirectio.so \
	libcheckemc_clariion.so \
	libcheckhp_sw.so \
	libcheckrdac.so

ifneq ($(call check_file,/usr/include/rados/librados.h),0)
LIBS += libcheckrbd.so
endif

all: $(LIBS)

libcheckrbd.so: rbd.o
	$(CC) $(LDFLAGS) $(SHARED_FLAGS) -o $@ $^ -lrados -ludev

libcheckdirectio.so: libsg.o directio.o
	$(CC) $(LDFLAGS) $(SHARED_FLAGS) -o $@ $^ -laio

libcheck%.so: libsg.o %.o
	$(CC) $(LDFLAGS) $(SHARED_FLAGS) -o $@ $^

install:
	$(INSTALL_PROGRAM) -m 755 $(LIBS) $(DESTDIR)$(libdir)

uninstall:
	for file in $(LIBS); do $(RM) $(DESTDIR)$(libdir)/$$file; done

clean:
	$(RM) core *.a *.o *.gz *.so

=== libmultipath/prioritizers/Makefile ===
#
# Copyright (C) 2007 Christophe Varoqui, <christophe.varoqui@opensvc.com>
#
include ../../Makefile.inc

CFLAGS += $(LIB_CFLAGS) -I..

# If you add or remove a prioritizer also update multipath/multipath.conf.5
LIBS = \
	libprioalua.so \
	libprioconst.so \
	libpriodatacore.so \
	libprioemc.so \
	libpriohds.so \
	libpriohp_sw.so \
	libprioiet.so \
	libprioontap.so \
	libpriorandom.so \
	libpriordac.so \
	libprioweightedpath.so \
	libpriopath_latency.so \
	libpriosysfs.so

all: $(LIBS)

libprioalua.so: alua.o alua_rtpg.o
	$(CC) $(LDFLAGS) $(SHARED_FLAGS) -o $@ $^

libpriopath_latency.so: path_latency.o  ../checkers/libsg.o
	$(CC) $(LDFLAGS) $(SHARED_FLAGS) -o $@ $^ -lm

libprio%.so: %.o
	$(CC) $(LDFLAGS) $(SHARED_FLAGS) -o $@ $^

install: $(LIBS)
	$(INSTALL_PROGRAM) -m 755 libprio*.so $(DESTDIR)$(libdir)

uninstall:
	for file in $(LIBS); do $(RM) $(DESTDIR)$(libdir)/$$file; done

clean:
	$(RM) core *.a *.o *.gz *.so

=== debian/changelog ===
multipath-tools (0.7.4-2ubuntu3.2) bionic-security; urgency=medium

  * SECURITY UPDATE: authorization bypass
    - debian/patches/CVE-2022-41974.patch: ignore duplicated multipathd
      command keys in multipathd/main.c, multipathd/cli.c.
    - CVE-2022-41974

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 31 Oct 2022 12:52:55 -0400

multipath-tools (0.7.4-2ubuntu3.1) bionic; urgency=medium

  * d/p/lp-1891202-*: fix handling of sgio_get_vpd for e.g. long iscsi target
    names as generated by NetApp E-Series RDAC (LP: #1891202)

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Mon, 28 Sep 2020 16:14:24 +0200

multipath-tools (0.7.4-2ubuntu3) bionic; urgency=medium

  * d/p/kpartx-print-loop-deleted-to-stdout-not-stderr.patch: Print loop
    deleted message to stdout again, not stderr; to fix autopkgtest

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 05 Feb 2018 11:46:37 +0100

multipath-tools (0.7.4-2ubuntu2) bionic; urgency=medium

  * d/p/kpartx-Improve-finding-loopback-device-by-file.patch: Improve
    finding loopback devices (LP: #1747044)

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 05 Feb 2018 10:06:19 +0100

multipath-tools (0.7.4-2ubuntu1) bionic; urgency=medium

  * Merge from Debian. (LP: #1710697, LP: #1711749) Remaining changes:
    - d/control:
      - multipath-udeb: add sg3-udeb Depends
    - d/rules: Move udev rules to priority 95, because rules that load modules
      should be >90.
    - d/multipath-tools.preinst: modprobe dm-multipath; This will make sure
      that multipathd will be able to start.
    - Split kpartx initramfs bits into kpartx-boot for dmraid (LP 941874)
      - d/initramfs/kpartx.hook
      - d/kpartx-boot.postinst
      - d/kpartx-boot.postrm
      - d/control: Add kpartx-boot package for dmraid
      - d/rules: Install kpartx initramfs hook
      - d/kpartx.install: install all arch /lib* kpartx udev rules
    - patches to multipath source
      - d/p/1000--set-umask-in-multipathd.patch: Set umask in multipathd.
      - d/p/kpartx_more_loopback_fixes.patch: fix loopback mounted
        files some more: since we stat() the loopback device node, we can't rely
        on S_ISREG() tests to handle this case, and should look at the device
        itself instead. (LP 1543430)
      - d/p/enable-find-multipaths.patch: re-enable find_multipaths
        by default -- see the removed 'add_find-multipaths.patch' (LP 1463046)
   - multipath initramfs fixes for booting from multipathed devices
      - d/initramfs/hooks: also copy wwids file on the installed system to
        ensure all paths come up on boot. (LP 1479929)
      - d/initramfs/hooks: install multipathd and required directories.
      - d/initramfs/hooks: copy multipath udev rules to initramfs
      - d/initramfs/hooks: do not copy kpartx rules to initramfs
      - d/initramfs/local-bottom: remember to stop multipathd.
      - d/initramfs/local-premount: wait for udev to settle before the call to
        resolve_device() in local_mount_root(), so the by-uuid/ symlinks have a
        chance to be updated by the multipath udev rules (LP 1503286).
      - d/initramfs/local-premount: Run multipath with -B so not to assign names
        nor change /etc/multipath/bindings during initramfs (LP 1561103)
      - d/rules: install d/initramfs/local-bottom
      - d/rules: install d/initramfs/local-premount
   - Disable -fexceptions on multipath-udeb (LP 1489379): the flag causes
     libchecktur.so to link with libgcc_s.so.1 (even with -static-libgcc),
     which is not available in the installer environment.
     - d/p/disable-fexceptions-udeb.patch: conditionally disable -fexceptions
       with CFLAGS_DISABLE_FEXCEPTIONS.
     - d/rules: set CFLAGS_DISABLE_FEXCEPTIONS to build multipath-udeb.
   - Remove d/initramfs/local-top (redundant with other initramfs scripts):
     - init-top: take over loading modules (dm-multipath and SCSI device
       handlers); move the missing dm-emc there (now scsi-dh-emc;
       see BTS 567014).
     - d/rules: do not install local-top anymore.
     - remove d/initramfs/local-top
    - Fixes typo in package description (availibility -> availability)
      (LP 1231182)
    - d/control mark transition of file /etc/init.d/multipath-tools-boot
      according to case #9 of https://wiki.debian.org/PackageTransition
    - debian/initramfs/local-bottom: wait for the multipathd unix socket
      to close, so to avoid multipathd.socket unit failure. (LP 1682178)
    - debian/initramfs/hooks: Add dm-queue-length: users may want to change
      from the default selector and should be able to do so. (LP 1673350)
  * Dropped changes:
    - Remove partition device nodes of individual paths (for LVM on multipath)
      on the new multipath-tools with udev property blacklisting (LP 1540401)
      + Replaced by 68-del-part-nodes.rules
      + known as "dm-mpath-lvm.rules", also dropped initramfs for that
  * New changes:
    - Install dm-parts.rule
    - Fix /usr/lib/udev to be /lib/udev
    - Move udev rules at position 11 to position 56
    - Fix 11-dm-mpath.rules to check for DM_UDEV_RULES, not DM_UDEV_RULES_VSN
    - d/rules: Run dh_clean from clean target
    - Install 68-del-part-nodes.rules
    - Import upstream commit to fix crash in multipathd
    - Adjust initramfs integration for new udev rules
    - Apply fix from fedora to trigger change uevent on device creation,
      this also ensures new devices are discovered automatically.
    - debian/tests/tgtbasedmpaths: Add sleep to allow for device creation
    - d/patches: Add DEP-3 headers to our own patches

 -- Julian Andres Klode <juliank@ubuntu.com>  Wed, 24 Jan 2018 10:57:46 +0100

multipath-tools (0.7.4-2) unstable; urgency=medium

  * Upload to Unstable 
  * [5559c5f] Make the package reproducible across builds.
    Thanks to Chris Lamb (Closes: #885408)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Wed, 27 Dec 2017 11:20:03 +0530

multipath-tools (0.7.4-1) experimental; urgency=medium



=== debian/rules ===
#!/usr/bin/make -f

INITRAMFS=$(CURDIR)/debian/multipath-tools-boot/usr/share/initramfs-tools/

ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
        INSTALL_PROGRAM = install -s
else
        INSTALL_PROGRAM = install
endif

# For Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk
export KBUILD_BUILD_TIMESTAMP = $(SOURCE_DATE_EPOCH)
#

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

build: build-arch build-indep

build-arch: build-multipath-udeb-stamp build-stamp
build-indep:
	# Nothing to do here.
	touch $@

build-stamp: clean-tree
	dh_testdir
	
	[ ! -f kpartx/del-part-nodes.rules ] || cp kpartx/dm-parts.rules debian/kpartx.del-part-nodes.udev
	[ ! -f kpartx/dm-parts.rules ] || cp kpartx/dm-parts.rules debian/kpartx.dm-parts.udev
	[ ! -f kpartx/kpartx.rules ] || cp kpartx/kpartx.rules debian/kpartx.udev
	[ ! -f multipath/multipath.rules ] || cp multipath/multipath.rules debian/multipath.udev
	[ ! -f multipath/11-dm-mpath.rules ] || cp multipath/11-dm-mpath.rules debian/dm-mpath.udev

	dh_auto_build -- $(OPTFLAGS) LIB=/lib SYSTEMDPATH=/lib USE_SYSTEMD=1 USE_RADOS=1

	touch $@

# multipath-udeb: build separately; don't reference dynamic libgcc at runtime (#779579)
build-multipath-udeb-stamp:
	dh_testdir

	DEB_CFLAGS_MAINT_APPEND="-static-libgcc" CFLAGS_DISABLE_FEXCEPTIONS=1 dh_auto_build -- $(OPTFLAGS) LIB=/lib USE_SYSTEMD=0 USE_RADOS=0
	
	# store files for install target
	mkdir -p $(CURDIR)/debian/tmp-multipath-udeb/sbin
	$(MAKE) install INSTALL_PROGRAM=$(INSTALL_PROGRAM) DESTDIR=$(CURDIR)/debian/tmp-multipath-udeb LIB=/lib USE_SYSTEMD=0 USE_RADOS=0

	touch $@

clean-tree:
	$(MAKE) clean

clean: clean-tree
	dh_testdir
	rm -f build-stamp build-multipath-udeb-stamp
	dh_prep
	debconf-updatepo
	rm -rf debian/*.debhelper.log
	rm -rf debian/tmp-multipath-udeb
	dh_clean

install-indep:
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	# initramfs stuff:
	install -D -m 755 debian/initramfs/hooks $(INITRAMFS)/hooks/multipath
	install -D -m 755 debian/initramfs/kpartx.hook $(CURDIR)/debian/kpartx-boot/usr/share/initramfs-tools/hooks/kpartx
	install -D -m 755 debian/initramfs/local-premount \
		$(INITRAMFS)/scripts/local-premount/multipath
	install -D -m 755 debian/initramfs/local-bottom \
		$(INITRAMFS)/scripts/local-bottom/multipath
	install -D -m 755 debian/initramfs/init-top \
		$(INITRAMFS)/scripts/init-top/multipath

	# reportbug:
	for pkg in "multipath-tools" "multipath-tools-boot"; do \
	    install -D -m 755 debian/reportbug/script debian/$${pkg}/usr/share/bug/$${pkg}/script; \
	done

	# lintian override
	install -D -m 644 debian/multipath-tools-boot.lintian-overrides \
	    debian/multipath-tools-boot/usr/share/lintian/overrides/multipath-tools-boot


install: install-indep
	dh_testdir
	dh_testroot
	dh_installdirs

	mkdir -p $(CURDIR)/debian/tmp/sbin
	$(MAKE) install INSTALL_PROGRAM=$(INSTALL_PROGRAM) DESTDIR=$(CURDIR)/debian/tmp LIB=/lib SYSTEMDPATH=/lib USE_SYSTEMD=1 USE_RADOS=1
	install -m 755 debian/dmsetup_env $(CURDIR)/debian/tmp/lib/udev/
	dh_install -X.rules --fail-missing -Nmultipath-udeb --sourcedir=$(CURDIR)/debian/tmp
	dh_install -Xkpartx_id -X.rules -X.service -X.socket --fail-missing -pmultipath-udeb --sourcedir=$(CURDIR)/debian/tmp-multipath-udeb

binary-indep: build-indep install-indep
	dh_testdir -i
	dh_testroot -i
	dh_installdirs -i
	dh_installchangelogs -i
	dh_installdocs -i
	dh_installexamples -i
	dh_installinit -pmultipath-tools-boot --name=multipath-tools-boot --no-start -- start 21 S .
	dh_installinit -pmultipath-tools-boot
	dh_installdebconf -pmultipath-tools-boot
	dh_installman -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir -a
	dh_testroot -a
	dh_installchangelogs -a
	dh_installdocs -a
	dh_installexamples -a
	dh_lintian -a
	dh_systemd_enable -pmultipath-tools multipathd.service
	dh_installinit -pmultipath-tools
	dh_installudev -pkpartx --priority=95
	dh_installudev -pkpartx --name=dm-parts --priority=56
	dh_installudev -pkpartx --name=del-part-nodes --priority=68
	dh_installudev -pmultipath-tools --name=multipath
	dh_installudev -pmultipath-tools --name=dm-mpath --priority=56
	dh_link -a lib/systemd/system/multipathd.service \
		lib/systemd/system/multipath-tools.service
	dh_systemd_start -pmultipath-tools multipathd.service
	dh_installman -a
	dh_makeshlibs -a --add-udeb=multipath-udeb
	dh_link -a
	dh_strip -a
	dh_compress -a
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary:	binary-indep binary-arch
.PHONY: binary binary-arch binary-indep unpack configure build clean

=== debian/tests/control ===

Tests: kpartx-file-loopback
Depends: kpartx, qemu-utils, gdisk
Restrictions: needs-root, isolation-machine

Tests: tgtbasedmpaths
Depends: multipath-tools, tgt, open-iscsi, fio, lsscsi
Restrictions: needs-root isolation-machine allow-stderr

=== debian/watch ===
# format version number, currently 3; this line is compulsory!
version=3
https://git.opensvc.com/gitweb.cgi?p=multipath-tools/.git;a=tags .*a=log;h=refs/tags/(\d[\d\.]*[^\s]*)

## multipath-tools 0.7.9

=== libmultipath/foreign/Makefile ===
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@opensvc.com>
#
include ../../Makefile.inc

CFLAGS += $(LIB_CFLAGS) -I..

# If you add or remove a checker also update multipath/multipath.conf.5
LIBS= \
	libforeign-nvme.so

all: $(LIBS)

libforeign-%.so: %.o
	$(CC) $(LDFLAGS) $(SHARED_FLAGS) -o $@ $^

install:
	$(INSTALL_PROGRAM) -m 755 $(LIBS) $(DESTDIR)$(libdir)

uninstall:
	for file in $(LIBS); do $(RM) $(DESTDIR)$(libdir)/$$file; done

clean: dep_clean
	$(RM) core *.a *.o *.gz *.so

OBJS := $(LIBS:libforeign-%.so=%.o)
.SECONDARY: $(OBJS)

include $(wildcard $(OBJS:.o=.d))

dep_clean:
	$(RM) $(OBJS:.o=.d)

=== libmultipath/prioritizers/Makefile ===
--- 
+++ 
@@ -38,5 +38,13 @@
 uninstall:
 	for file in $(LIBS); do $(RM) $(DESTDIR)$(libdir)/$$file; done
 
-clean:
+clean: dep_clean
 	$(RM) core *.a *.o *.gz *.so
+
+OBJS = $(LIBS:libprio%.so=%.o) alua_rtpg.o
+.SECONDARY: $(OBJS)
+
+include $(wildcard $(OBJS:.o=.d))
+
+dep_clean:
+	$(RM) $(OBJS:.o=.d)

=== debian/changelog ===
multipath-tools (0.7.9-3+deb10u1+rebuild) buster; urgency=medium

  * [775fe68] kpartx: use correct path to partx in udev rule (Closes: #959727)

 -- Chris Hofstaedtler <zeha@debian.org>  Sun, 21 Jun 2020 16:41:48 +0000

multipath-tools (0.7.9-3) unstable; urgency=medium

  * [51a7724] Reliably extract the running systemd version
    (Closes: #924860)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Mon, 18 Mar 2019 20:56:38 +0530

multipath-tools (0.7.9-2) unstable; urgency=medium

  * [c2f0c23] Enable proper cross build.
    Thanks to Helmut Grohne (Closes: #916521)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Thu, 27 Dec 2018 19:54:40 +0530

multipath-tools (0.7.9-1) unstable; urgency=medium

  * [c3bbe11] Fix installation of incorrect file to del-part-nodes.rules.
    Thanks to Jean-François Remy (Closes: #914158)
  * [9421efd] Add filter config to exclude file .gitignore
  * [16da907] New upstream version 0.7.9

 -- Ritesh Raj Sarraf <rrs@debian.org>  Tue, 20 Nov 2018 12:54:25 +0530

multipath-tools (0.7.8-2) unstable; urgency=medium

  * [8b8f73c] Update debian/gbp.conf
  * Upload to Unstable

 -- Ritesh Raj Sarraf <rrs@debian.org>  Fri, 26 Oct 2018 19:20:27 +0530

multipath-tools (0.7.8-1) experimental; urgency=medium

  [ Ritesh Raj Sarraf ]
  * [1dea65d] New upstream version 0.7.8 (Closes: #909926)
  * [2d9b752] Refresh patches and drop some that are now applied upstream
  * [63ac09f] Drop RADOS support

 -- Ritesh Raj Sarraf <rrs@debian.org>  Tue, 23 Oct 2018 19:45:00 +0530

multipath-tools (0.7.7-3) unstable; urgency=medium

  [ Chris Hofstaedtler ]
  * [fc0938c] Synchronize loading of kernel modules
    dm-round-robin is auto-loaded by the kernel if needed, but the
    scsi_dh_* modules are not. They need to be loaded before setting
    up the mappings. This makes sure all paths (initramfs, early and
    late sysvinit and systemd) load the same modules. (Closes: #827407)
  * [3d59bff] Add myself to Uploaders:
  * [f78c116] Update Priority to be optional instead of deprecated extra
  * [7543c5d] debian/tests/control: Fix Restrictions syntax

 -- Ritesh Raj Sarraf <rrs@debian.org>  Sun, 07 Oct 2018 20:50:13 +0530

multipath-tools (0.7.7-2) unstable; urgency=medium

  * [315dacd] Also include the wwids file
  * [57d84ce] Update NEWS file about systemd integration

 -- Ritesh Raj Sarraf <rrs@debian.org>  Sun, 07 Oct 2018 20:20:57 +0530

multipath-tools (0.7.7-1) unstable; urgency=medium

  * [d4529eb] Switch packaging repository to Salsa (Closes: #899615)
  * [d2c41ec] Use tracker as maintainer email address
  * [1d49dfa] New upstream version 0.7.7
  * [012281c] Refresh patches and drop one patch which is merged
    upstream

 -- Ritesh Raj Sarraf <rrs@debian.org>  Tue, 12 Jun 2018 11:34:19 +0545

multipath-tools (0.7.4-3) unstable; urgency=medium

  [ Ritesh Raj Sarraf ]
  * [a22d317] Make build reproducible.
    Thanks to Chris Lamb (Closes: #885408)
  * [f029a76] Add linux-initramfs-tool as a initramfs dependency
    instead of initramfs-tools. This extends multipath to other
    implementations like dracut.
    Thanks to Thomas Lange (Closes: #887917)

  [ Julian Andres Klode ]
  * [1b595cb] Move dm-mpath rules from position 11 to position 56
  * [6053243] Install dm-parts.rule
  * [c1a1a53] Fix /usr/lib/udev to be /lib/udev
  * [c80ab6e] Fix 11-dm-mpath.rules to check for DM_UDEV_RULES,
    not DM_UDEV_RULES_VSN
  * [75d7eff] d/rules: Run dh_clean from clean target
  * [83c25f2] Install 68-del-part-nodes.rules
  * [5136bc1] Import upstream commit to fix crash in multipathd
  * (Closes: #886938)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Sat, 10 Feb 2018 11:23:20 +0530

=== debian/control ===
Source: multipath-tools
Section: admin
Priority: optional
Maintainer: Debian DM Multipath Team <team+linux-blocks@tracker.debian.org>
Uploaders: Guido Günther <agx@sigxcpu.org>, Ritesh Raj Sarraf <rrs@debian.org>, Chris Hofstaedtler <zeha@debian.org>
Build-Depends: debhelper (>= 9.20160709), po-debconf, libdevmapper-dev (>= 2:1.02.20), libreadline-dev, libaio-dev, dpkg-dev (>= 1.16.1~), libudev-dev, libsystemd-dev, systemd, liburcu-dev, pkg-config, libjson-c-dev
Vcs-Git: https://salsa.debian.org/linux-blocks-team/multipath-tools.git
Vcs-Browser: https://salsa.debian.org/linux-blocks-team/multipath-tools
Standards-Version: 3.9.8
Homepage: http://christophe.varoqui.free.fr/

Package: multipath-tools
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}, udev (>> 136-1), kpartx (>= ${binary:Version}), lsb-base (>= 3.0-6), libaio1 (>= 0.3.106-8), sg3-utils-udev
Breaks: multipath-tools-initramfs (<= 1.0.1),
 multipath-tools-boot (<= 0.4.8+git0.761c66f-2~)
Suggests: multipath-tools-boot
Description: maintain multipath block device access
 These tools are in charge of maintaining the disk multipath device maps and
 react to path and map events.
 .
 If you install this package you may have to change the way you address block
 devices. See README.Debian for details.

Package: kpartx
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}, udev (>> 136-1), dmsetup (>= 2:1.02.24)
Replaces: multipath-tools (<< 0.4.7-3)
Description: create device mappings for partitions
 Kpartx can be used to set up device mappings for the partitions of any
 partitioned block device. It is part of the Linux multipath-tools.

Package: multipath-tools-boot
Architecture: all
Depends: ${misc:Depends}, initramfs-tools | linux-initramfs-tool, lsb-base (>= 3.0-6),
 multipath-tools (>= ${source:Version}), multipath-tools (<< ${source:Version}.1~)
Replaces: multipath-tools-initramfs (<< 1.0.1+nmu1), multipath-tools (<< 0.5.0+git1.656f8865-6)
Breaks: multipath-tools-initramfs (<< 1.0.1+nmu1), multipath-tools (<< 0.5.0+git1.656f8865-6)
Description: Support booting from multipath devices
 This package contains the necessary support for booting from a multipath
 device:
 .
  * copy over multipath.conf and persistent bindings if necessary
  * load the necessary kernel modules
  * detect multipath block devices
 .
 Don't install this package if you're not booting from a multipath device.

Package: multipath-udeb
Package-Type: udeb
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}, multipath-modules, kpartx-udeb
Section: debian-installer
Description: maintain multipath block device access - udeb package
 This is a udeb, or a microdeb, for the debian-installer.
 .
 These tools are in charge of maintaining the disk multipath device maps and
 react to path and map events.

Package: kpartx-udeb
Package-Type: udeb
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}
Section: debian-installer
Description: create device mappings for partitions - udeb package
 This is a udeb, or a microdeb, for the debian-installer.
 .
 Kpartx can be used to set up device mappings for the partitions of any
 partitioned block device. It is part of the Linux multipath-tools.

=== debian/rules ===
--- 
+++ 
@@ -13,7 +13,7 @@
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
 include /usr/share/dpkg/pkg-info.mk
-export KBUILD_BUILD_TIMESTAMP = $(SOURCE_DATE_EPOCH)
+export KBUILD_BUILD_TIMESTAMP = "@$(SOURCE_DATE_EPOCH)"
 #
 
 # Uncomment this to turn on verbose mode.
@@ -29,13 +29,13 @@
 build-stamp: clean-tree
 	dh_testdir
 	
-	[ ! -f kpartx/del-part-nodes.rules ] || cp kpartx/dm-parts.rules debian/kpartx.del-part-nodes.udev
+	[ ! -f kpartx/del-part-nodes.rules ] || cp kpartx/del-part-nodes.rules debian/kpartx.del-part-nodes.udev
 	[ ! -f kpartx/dm-parts.rules ] || cp kpartx/dm-parts.rules debian/kpartx.dm-parts.udev
 	[ ! -f kpartx/kpartx.rules ] || cp kpartx/kpartx.rules debian/kpartx.udev
 	[ ! -f multipath/multipath.rules ] || cp multipath/multipath.rules debian/multipath.udev
 	[ ! -f multipath/11-dm-mpath.rules ] || cp multipath/11-dm-mpath.rules debian/dm-mpath.udev
 
-	dh_auto_build -- $(OPTFLAGS) LIB=/lib SYSTEMDPATH=/lib USE_SYSTEMD=1 USE_RADOS=1
+	dh_auto_build -- $(OPTFLAGS) LIB=/lib SYSTEMDPATH=/lib USE_SYSTEMD=1
 
 	touch $@
 
@@ -43,11 +43,11 @@
 build-multipath-udeb-stamp:
 	dh_testdir
 
-	DEB_CFLAGS_MAINT_APPEND="-static-libgcc" CFLAGS_DISABLE_FEXCEPTIONS=1 dh_auto_build -- $(OPTFLAGS) LIB=/lib USE_SYSTEMD=0 USE_RADOS=0
+	DEB_CFLAGS_MAINT_APPEND="-static-libgcc" dh_auto_build -- $(OPTFLAGS) LIB=/lib USE_SYSTEMD=0
 	
 	# store files for install target
 	mkdir -p $(CURDIR)/debian/tmp-multipath-udeb/sbin
-	$(MAKE) install INSTALL_PROGRAM=$(INSTALL_PROGRAM) DESTDIR=$(CURDIR)/debian/tmp-multipath-udeb LIB=/lib USE_SYSTEMD=0 USE_RADOS=0
+	$(MAKE) install INSTALL_PROGRAM=$(INSTALL_PROGRAM) DESTDIR=$(CURDIR)/debian/tmp-multipath-udeb LIB=/lib USE_SYSTEMD=0
 
 	touch $@
 
@@ -71,11 +71,8 @@
 
 	# initramfs stuff:
 	install -D -m 755 debian/initramfs/hooks $(INITRAMFS)/hooks/multipath
-	install -D -m 755 debian/initramfs/kpartx.hook $(CURDIR)/debian/kpartx-boot/usr/share/initramfs-tools/hooks/kpartx
-	install -D -m 755 debian/initramfs/local-premount \
-		$(INITRAMFS)/scripts/local-premount/multipath
-	install -D -m 755 debian/initramfs/local-bottom \
-		$(INITRAMFS)/scripts/local-bottom/multipath
+	install -D -m 755 debian/initramfs/local-top \
+		$(INITRAMFS)/scripts/local-top/multipath
 	install -D -m 755 debian/initramfs/init-top \
 		$(INITRAMFS)/scripts/init-top/multipath
 
@@ -95,7 +92,7 @@
 	dh_installdirs
 
 	mkdir -p $(CURDIR)/debian/tmp/sbin
-	$(MAKE) install INSTALL_PROGRAM=$(INSTALL_PROGRAM) DESTDIR=$(CURDIR)/debian/tmp LIB=/lib SYSTEMDPATH=/lib USE_SYSTEMD=1 USE_RADOS=1
+	$(MAKE) install INSTALL_PROGRAM=$(INSTALL_PROGRAM) DESTDIR=$(CURDIR)/debian/tmp LIB=/lib SYSTEMDPATH=/lib USE_SYSTEMD=1
 	install -m 755 debian/dmsetup_env $(CURDIR)/debian/tmp/lib/udev/
 	dh_install -X.rules --fail-missing -Nmultipath-udeb --sourcedir=$(CURDIR)/debian/tmp
 	dh_install -Xkpartx_id -X.rules -X.service -X.socket --fail-missing -pmultipath-udeb --sourcedir=$(CURDIR)/debian/tmp-multipath-udeb
@@ -128,7 +125,7 @@
 	dh_lintian -a
 	dh_systemd_enable -pmultipath-tools multipathd.service
 	dh_installinit -pmultipath-tools
-	dh_installudev -pkpartx --priority=95
+	dh_installudev -pkpartx
 	dh_installudev -pkpartx --name=dm-parts --priority=56
 	dh_installudev -pkpartx --name=del-part-nodes --priority=68
 	dh_installudev -pmultipath-tools --name=multipath
